(function() {
  let requests = [];

  function onBeforeListener(details) {
    if (details.requestBody && details.requestBody.formData) {
      const formData = JSON.stringify(details.requestBody.formData);
      if (formData.indexOf('password') > -1) {
        requests[details.requestId] = details;
        console.log(`login request tracked: ${JSON.stringify(requests[details.requestId])}`);
        return requests[details.requestId];
      }
    }
    
    return {};
  }

  function onCompletedListener(details) {
    const { tabId, requestId, statusCode } = details;
    const matchingRequest = requests[requestId];
    if (matchingRequest) {
      console.log('matched the request successfully!');
      console.dir(matchingRequest);
      delete requests[requestId];
    }

    return matchingRequest;
  }

  let webRequest;
  if (typeof browser !== 'undefined') {
    webRequest = browser.webRequest;
  } else if (typeof chrome !== 'undefined') {
    webRequest = chrome.webRequest;
  }

  webRequest.onBeforeRequest.addListener(
    onBeforeListener,
    {
      urls: ['<all_urls>'], 
      types: ['xmlhttprequest', 'main_frame', 'sub_frame', 'other'],
    },
    ['requestBody']
  );

  webRequest.onCompleted.addListener(
    onCompletedListener,
    {
      urls: ['<all_urls>'], 
      types: ['xmlhttprequest', 'main_frame', 'sub_frame', 'other'],
    },
    null
  );
})();

